/* =============================================================================
 * conjunto.h
 *
 * Interfaz pblica del TAD Conjunto - Versin 1.
 *
 * En esta versin los elementos de un conjunto son int.
 * Por ello, algunas de las primitivas del TAD son dependientes de ese tipo de
 * dato.
 * Esta implementacin del TAD no vale para almacenar otro tipo de dato.
 * Si se quiere tener un conjunto con elementos que no sean int, habra que
 * implementar un nuevo TAD.
 *
 * Autor: Ivn Cantador
 * Fecha: 9/2/2017
 * Versin: 1.0
 * Comentarios: En este fichero habra que incluir las cabeceras de funcin,
 * describiendo las primitivas, sus argumentos de entrada y valores de salida.
 * ========================================================================== */

#ifndef CONJUNTO_H
#define CONJUNTO_H

#include "tipos.h"

typedef struct _Conjunto Conjunto;

Conjunto *conjunto_crear();
void conjunto_vaciar(Conjunto *cjto);
void conjunto_eliminar(Conjunto *cjto);
int conjunto_cardinalidad(Conjunto *cjto);
boolean conjunto_estaVacio(Conjunto *cjto);
boolean conjunto_estaLleno(Conjunto *cjto);
int conjunto_obtenerElemento(Conjunto *cjto, int pos);
int conjunto_buscarElemento(Conjunto *cjto, int elem);
status conjunto_insertarElemento(Conjunto *cjto, int elem);
void conjunto_visualizar(Conjunto *c);
Conjunto *conjunto_union(Conjunto *a, Conjunto *b);
Conjunto *conjunto_interseccion(Conjunto *a, Conjunto *b);

#endif
