/* =============================================================================
 * conjunto2.h
 *
 * Interfaz pblica del TAD Conjunto - Versin 2.
 *
 * En esta versin los elementos de un conjunto son Elemento *.
 * Las primitivas del TAD son independientes del tipo de dato que almacenen los
 * elementos.
 * En esta implementacin del TAD, un elemento almacena un int.
 * Si se quiere tener un conjunto con elementos que no sean int, las primitivas
 * del TAD no hay que cambiarlas, pero habra que modificar la estructura de
 * datos y funciones de Elemento (ver elemento.h y elemento.c).
 *
 * Autor: Ivn Cantador
 * Fecha: 9/2/2017
 * Versin: 2.0
 * Comentarios: En este fichero habra que incluir las cabeceras de funcin,
 * describiendo las primitivas, sus argumentos de entrada y valores de salida.
 * ========================================================================== */

#ifndef CONJUNTO2_H
#define CONJUNTO2_H

#include "tipos.h"
#include "elemento.h"

typedef struct _Conjunto2 Conjunto2;

Conjunto2 *conjunto2_crear();
void conjunto2_vaciar(Conjunto2 *cjto);
void conjunto2_eliminar(Conjunto2 *cjto);
int conjunto2_cardinalidad(Conjunto2 *cjto);
boolean conjunto2_estaVacio(Conjunto2 *cjto);
boolean conjunto2_estaLleno(Conjunto2 *cjto);
Elemento *conjunto2_obtenerElemento(Conjunto2 *cjto, int pos);
int conjunto2_buscarElemento(Conjunto2 *cjto, Elemento *elem);
status conjunto2_insertarElemento(Conjunto2 *cjto, Elemento*elem);
void conjunto2_visualizar(Conjunto2 *cjto);
Conjunto2 *conjunto2_union(Conjunto2 *cjtoA, Conjunto2 *cjtoB);
Conjunto2 *conjunto2_interseccion(Conjunto2 *cjtoA, Conjunto2 *cjtoB);

#endif
