/* =============================================================================
 * conjunto3.h
 *
 * Interfaz pblica del TAD Conjunto - Versin 3.
 *
 * En esta versin los elementos de un conjunto son void *.
 * Las primitivas del TAD son independientes del tipo de dato que almacenen los
 * elementos.
 * En esta implementacin del TAD, los datos de un conjunto son opacos y se
 * manejan por una serie de funciones que se almacenan en la estrucutra Conjunto.
 * Estas funciones se pasan como argumentos de entrada en conjunto3_crear.
 *
 * Autor: Ivn Cantador
 * Fecha: 9/2/2017
 * Versin: 3.0
 * Comentarios: En este fichero habra que incluir las cabeceras de funcin,
 * describiendo las primitivas, sus argumentos de entrada y valores de salida.
 * ========================================================================== */

#ifndef CONJUNTO3_H
#define CONJUNTO3_H

#include "tipos.h"

typedef struct _Conjunto3 Conjunto3;

Conjunto3 *conjunto3_crear(void *(*fnc_copiar)(void *), int (*fnc_comparar)(void *, void *), void (*fnc_eliminar)(void *), void (*fnc_visualizar)(void *));
void conjunto3_vaciar(Conjunto3 *cjto);
void conjunto3_eliminar(Conjunto3 *cjto);
int conjunto3_cardinalidad(Conjunto3 *cjto);
boolean conjunto3_estaVacio(Conjunto3 *cjto);
boolean conjunto3_estaLleno(Conjunto3 *cjto);
void *conjunto3_obtenerElemento(Conjunto3 *cjto, int pos);
int conjunto3_buscarElemento(Conjunto3 *cjto, void *elem);
status conjunto3_insertarElemento(Conjunto3 *cjto, void *elem);
void conjunto3_visualizar(Conjunto3 *cjto);
Conjunto3 *conjunto3_union(Conjunto3 *cjtoA, Conjunto3 *cjtoB);
Conjunto3 *conjunto3_interseccion(Conjunto3 *cjtoA, Conjunto3 *cjtoB);

#endif
