/* =============================================================================
 * main1.c
 *
 * Programa para probar primitivas del TAD Conjunto - Versin 1.
 * Los elementos de un conjunto son int.
 *
 * Autor: Ivn Cantador
 * Fecha: 9/2/2017
 * Versin: 1.0
 * ========================================================================== */

#include <stdio.h>
#include "conjunto.h"

int main1() {
	Conjunto *A = NULL, *B = NULL, *C = NULL;

	A = conjunto_crear();
	if ( A == NULL ) {
		return -1;
	}

	B = conjunto_crear();
	if ( B == NULL ) {
		conjunto_eliminar(A);
		return -1;
	}

	printf("Prueba del TAD Conjunto, version 1 - elementos de tipo int\n");

	conjunto_insertarElemento(A, 1);
	conjunto_insertarElemento(A, 2);
	conjunto_insertarElemento(A, 3);
	printf("Conjunto A:\n");
	conjunto_visualizar(A);

	conjunto_insertarElemento(B, 3);
	conjunto_insertarElemento(B, 4);
	conjunto_insertarElemento(B, 5);
	conjunto_insertarElemento(B, 6);
	printf("Conjunto B:\n");
	conjunto_visualizar(B);

	C = conjunto_union(A, B);
	printf("Conjunto Union:\n");
	conjunto_visualizar(C);
	conjunto_eliminar(C);

	C = conjunto_interseccion(A, B);
	printf("Conjunto Interseccion:\n");
	conjunto_visualizar(C);
	conjunto_eliminar(C);

	conjunto_eliminar(A);
	conjunto_eliminar(B);

	return 1;
}
