/* =============================================================================
 * main2.c
 *
 * Programa para probar primitivas del TAD Conjunto - Versin 2.
 * Los elementos de un conjunto son Elemento *, donde Elemento encapsula un int.
 *
 * Autor: Ivn Cantador
 * Fecha: 9/2/2017
 * Versin: 1.0
 * ========================================================================== */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "tipos.h"
#include "elemento.h"
#include "conjunto2.h"

int main2() {
	Conjunto2 *A = NULL, *B = NULL, *C = NULL;
	Elemento *e = NULL;

	A = conjunto2_crear();
	if ( A == NULL ) {
		return -1;
	}

	B = conjunto2_crear();
	if ( B == NULL ) {
		conjunto2_eliminar(A);
		return -1;
	}

	e = elemento_crear(0);
	if ( e == NULL ) {
		conjunto2_eliminar(A);
		conjunto2_eliminar(B);
	}

	printf("Prueba del TAD Conjunto, version 2 - elementos de tipo Elemento* (almacenando int)\n");

	elemento_establecerDato(e, 1); conjunto2_insertarElemento(A, e);
	elemento_establecerDato(e, 2); conjunto2_insertarElemento(A, e);
	elemento_establecerDato(e, 3); conjunto2_insertarElemento(A, e);
	printf("Conjunto A:\n");
	conjunto2_visualizar(A);

	elemento_establecerDato(e, 3); conjunto2_insertarElemento(B, e);
	elemento_establecerDato(e, 4); conjunto2_insertarElemento(B, e);
	elemento_establecerDato(e, 5); conjunto2_insertarElemento(B, e);
	elemento_establecerDato(e, 6); conjunto2_insertarElemento(B, e);
	printf("Conjunto B:\n");
	conjunto2_visualizar(B);

	C = conjunto2_union(A, B);
	printf("Conjunto Union:\n");
	conjunto2_visualizar(C);
	conjunto2_eliminar(C);

	C = conjunto2_interseccion(A, B);
	printf("Conjunto Interseccion:\n");
	conjunto2_visualizar(C);
	conjunto2_eliminar(C);

	conjunto2_eliminar(A);
	conjunto2_eliminar(B);

	elemento_eliminar(e);

	return 1;
}
