/* =============================================================================
 * tipos.h
 *
 * Definicin de constantes y tipos de datos genricos.
 *
 * Autor: Ivn Cantador
 * Fecha: 9/2/2017
 * Versin: 1.0
 * ========================================================================== */

#ifndef TIPOS_H_
#define TIPOS_H_

#include <limits.h>

// NAN significa "Not A Number", y se usa para valores enteros no vlidos en un programa
// INT_MAX es el valor mximo de un int, y est definindo en limits.h
#define NAN INT_MAX

// Tipo de dato Booleano, que toma uno de dos valores: falso o verdadero
typedef enum {NULL_BOOLEAN=-1, FALSE=0, TRUE=1} boolean;

// Tipo de datos Status, que se usa para gestionar cdigos de error en las funciones de un programa
typedef enum {ERROR=0, OK=1} status;

#endif
